Module javafx.base
Package javafx.beans.property

# Class ReadOnlySetPropertyBase<E>

java.lang.Object
javafx.beans.binding.SetExpression<E>
javafx.beans.property.ReadOnlySetProperty<E>
javafx.beans.property.ReadOnlySetPropertyBase<E>

Type Parameters:
  `E` - the type of the `Set` elements

All Implemented Interfaces:
  `Iterable<E>`, `Collection<E>`, `Set<E>`, `Observable`, `ReadOnlyProperty<ObservableSet<E>>`, `ObservableObjectValue<ObservableSet<E>>`, `ObservableSetValue<E>`, `ObservableValue<ObservableSet<E>>`, `ObservableSet<E>`

public abstract class ReadOnlySetPropertyBase<E> extends ReadOnlySetProperty<E>
Base class for all readonly properties wrapping an `ObservableSet`. This class provides a default implementation to attach listener.

Since:
  JavaFX 2.1
See Also:
  - `ReadOnlySetProperty`

- ## Property Summary

  ### Properties declared in class javafx.beans.binding.SetExpression

  `empty, size`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ReadOnlySetPropertyBase()`
  Creates a default `ReadOnlySetPropertyBase`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addListener(InvalidationListener listener)`
  Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid.
  `void`
  `addListener(ChangeListener<? super ObservableSet<E>> listener)`
  Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes.
  `void`
  `addListener(SetChangeListener<? super E> listener)`
  Add a listener to this observable set.
  `protected void`
  `fireValueChangedEvent()`
  This method needs to be called if the reference to the `ObservableSet` changes.
  `protected void`
  `fireValueChangedEvent(SetChangeListener.Change<? extends E> change)`
  This method needs to be called if the content of the referenced `ObservableSet` changes.
  `void`
  `removeListener(InvalidationListener listener)`
  Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.
  `void`
  `removeListener(ChangeListener<? super ObservableSet<E>> listener)`
  Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.
  `void`
  `removeListener(SetChangeListener<? super E> listener)`
  Tries to removed a listener from this observable set.

  ### Methods declared in class javafx.beans.property.ReadOnlySetProperty

  `bindContent, bindContentBidirectional, equals, hashCode, toString, unbindContent, unbindContentBidirectional`

  ### Methods declared in class javafx.beans.binding.SetExpression

  `add, addAll, asString, clear, contains, containsAll, emptyProperty, getSize, getValue, isEmpty, isEqualTo, isNotEqualTo, isNotNull, isNull, iterator, remove, removeAll, retainAll, setExpression, size, sizeProperty, toArray, toArray`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface java.util.Collection

  `parallelStream, removeIf, stream, toArray`

  ### Methods declared in interface java.lang.Iterable

  `forEach`

  ### Methods declared in interface javafx.beans.Observable

  `subscribe`

  ### Methods declared in interface javafx.beans.value.ObservableObjectValue

  `get`

  ### Methods declared in interface javafx.beans.value.ObservableValue

  `flatMap, getValue, map, orElse, subscribe, subscribe, when`

  ### Methods declared in interface javafx.beans.property.ReadOnlyProperty

  `getBean, getName`

  ### Methods declared in interface java.util.Set

  `spliterator`

- ## Constructor Details

  - ### ReadOnlySetPropertyBase

    public ReadOnlySetPropertyBase()
    Creates a default `ReadOnlySetPropertyBase`.

- ## Method Details

  - ### addListener

    public void addListener(InvalidationListener listener)
    Description copied from interface: `Observable`
    Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same actual `InvalidationListener` instance may be safely registered for different `Observables`.

    The `Observable` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakInvalidationListener` avoid this situation.

    Parameters:
      `listener` - The listener to register
    See Also:
      - `Observable.removeListener(InvalidationListener)`

  - ### removeListener

    public void removeListener(InvalidationListener listener)
    Description copied from interface: `Observable`
    Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.

    If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

    Parameters:
      `listener` - The listener to remove
    See Also:
      - `Observable.addListener(InvalidationListener)`

  - ### addListener

    public void addListener(ChangeListener<? super ObservableSet<E>> listener)
    Description copied from interface: `ObservableValue`
    Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same actual `ChangeListener` instance may be safely registered for different `ObservableValues`.

    The `ObservableValue` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakChangeListener` avoid this situation.

    Parameters:
      `listener` - The listener to register
    See Also:
      - `ObservableValue.removeListener(ChangeListener)`

  - ### removeListener

    public void removeListener(ChangeListener<? super ObservableSet<E>> listener)
    Description copied from interface: `ObservableValue`
    Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

    If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

    Parameters:
      `listener` - The listener to remove
    See Also:
      - `ObservableValue.addListener(ChangeListener)`

  - ### addListener

    public void addListener(SetChangeListener<? super E> listener)
    Description copied from interface: `ObservableSet`
    Add a listener to this observable set.
    Parameters:
      `listener` - the listener for listening to the set changes

  - ### removeListener

    public void removeListener(SetChangeListener<? super E> listener)
    Description copied from interface: `ObservableSet`
    Tries to removed a listener from this observable set. If the listener is not attached to this list, nothing happens.
    Parameters:
      `listener` - a listener to remove

  - ### fireValueChangedEvent

    protected void fireValueChangedEvent()
    This method needs to be called if the reference to the `ObservableSet` changes. It sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `SetChangeListener`. This method needs to be called, if the value of this property changes.

  - ### fireValueChangedEvent

    protected void fireValueChangedEvent(SetChangeListener.Change<? extends E> change)
    This method needs to be called if the content of the referenced `ObservableSet` changes. Sends notifications to all attached `InvalidationListeners`, `ChangeListeners`, and `SetChangeListener`. This method is called when the content of the list changes.
    Parameters:
      `change` - the change that needs to be propagated